#include "keys.h"

/* --------------------------------------------------------------------------------- */
void initKeys() {
	RABPU = 0;
	PORTA &= ~KEY_MASQ; //mclr PORTA
	ANSEL = 0x00; //digital I/O
	TRISA |= KEY_MASQ; // port RA0 jako wejcie
	WPUA = 0xff; //pull-up
	keyS1counter = 0;
	keyS2counter = 0;
	keyS4counter = 0;
	led_blink_counter = 0;
	key_counter = 0;	
}

/* --------------------------------------------------------------------------------- */
void handleKeys() {
	u8 tmp;
	u8 key_conf;

	//--------------- getting events from states of switches -----------------------
	TMR2IE = 0; //t1 interrupt disabled
	for(key_conf = 0; key_conf < 4; key_conf++) {
		keysState[key_conf].fp = 0;
		keysState[key_conf].fpl = 0;
		keysState[key_conf].fr = 0;
		keysState[key_conf].frl = 0;		

		if(keysState[key_conf].d == 1 && keysState[key_conf].dt == 0)
			keysState[key_conf].fp = 1;
		if(keysState[key_conf].dl == 1 && keysState[key_conf].dlt == 0)
			keysState[key_conf].fpl = 1;

		if(keysState[key_conf].dl == 0 && keysState[key_conf].dlt == 1) {
			keysState[key_conf].frl = 1;
		} else if(keysState[key_conf].d == 0 && keysState[key_conf].dt == 1) {
			keysState[key_conf].fr = 1;
		}

		keysState[key_conf].dt = keysState[key_conf].d;
		keysState[key_conf].dlt = keysState[key_conf].dl;
	}
	TMR2IE = 1; //t1interrupt enabled
	
	if(keysState[STATE_S1S4_IDX].fp == 1) {
		keysState[STATE_S1_IDX].fp = 0;
		keysState[STATE_S4_IDX].fp = 0;
		keysState[STATE_S1_IDX].fpl = 0;
		keysState[STATE_S4_IDX].fpl = 0;
		keysState[STATE_S1_IDX].d = 0;
		keysState[STATE_S1_IDX].dt = 0;		
		keysState[STATE_S4_IDX].d = 0;
		keysState[STATE_S4_IDX].dt = 0;		
	}	
}
/* --------------------------------------------------------------------------------- */
